use strict;
use warnings;
use Test::More;
use lib './t/lib';
use PScm::Test tests => 38;

BEGIN { use_ok('PScm') }

eval_ok('(eq? 1 1)', '1', 'eq numbers');
eval_ok('(eq? 1 2)', '0', 'neq numbers');
eval_ok('(eq? 1 "1")', '0', 'neq numbers and strings');
eval_ok("(eq? 1 'a)", '0', 'neq numbers and symbols');
eval_ok("(eq? 1 (list 1))", '0', 'neq numbers and lists');

eval_ok('(eq? "a" "a")', '1', 'eq strings');
eval_ok('(eq? "a" "b")', '0', 'neq strings');
eval_ok('(eq? "1" 1)', '0', 'neq strings and numbers');
eval_ok('(eq? "a" \'a)', '0', 'neq strings and symbols');
eval_ok('(eq? "a" (list "a"))', '0', 'neq strings and lists');

eval_ok("(eq? 'a 'a)", '1', 'eq symbols');
eval_ok("(eq? 'a 'b)", '0', 'neq symbols');
eval_ok("(eq? 'a 1)", '0', 'neq symbols and numbers');
eval_ok('(eq? \'a "a")', '0', 'neq symbols and strings');
eval_ok("(eq? 'a (list 'a))", '0', 'neq symbols and lists');

eval_ok("(eq? (list 1 2) (list 1 2))", '1', 'eq lists');
eval_ok("(eq? (list 1 2) (list 1 2 3))", '0', 'neq lists');
eval_ok("(eq? (list 1) 1)", '0', 'neq lists and numbers');
eval_ok('(eq? (list "a") "a")', '0', 'neq lists and strings');
eval_ok("(eq? (list 'a) 'a)", '0', 'neq lists and symbols');

eval_ok("(eq? () ())", '1', 'eq empty lists');
eval_ok("(eq? () (list 1))", '0', 'neq empty lists');
eval_ok("(eq? 1 1 1 1)", '1', 'eq multiple arguments');
eval_ok("(eq? 1 1 1 2)", '0', 'neq multiple arguments');

eval_ok("(< 1 2 3 4)", '1', '< multiple arguments');
eval_ok("(< 1 2 3 3)", '0', '!< multiple arguments');

eval_ok("(<= 1 2 3 3)", '1', '<= multiple arguments');
eval_ok("(<= 1 2 3 2)", '0', '!<= multiple arguments');

eval_ok("(> 4 3 2 1)", '1', '> multiple arguments');
eval_ok("(> 4 3 2 2)", '0', '!> multiple arguments');

eval_ok("(>= 4 3 2 2)", '1', '>= multiple arguments');
eval_ok("(>= 4 3 2 3)", '0', '!>= multiple arguments');

eval_ok("(and 1 2 3)", "3", 'and success');
eval_ok("(and 1 2 () 3)", "()", 'and failure');

eval_ok("(or 1 2 3)", "1", 'or success');
eval_ok("(or 0 0 3 0)", "3", 'or success [2]');
eval_ok("(or 0 0 0 0)", "0", 'or failure');

# vim: ft=perl
