use strict;
use warnings;
use Test::More;
use lib './t/lib';
use PScm::Test tests => 3;

BEGIN { use_ok('PScm') }

eval_ok(<<EOF, <<EOR, 'let does not support recursion');
(let ((factorial
        (lambda (n)
          (if n (* n (factorial (- n 1)))
                1))))
  (factorial 4))
EOF
Error: no binding for factorial in PScm::Env
EOR

eval_ok(<<EOF, "24", 'letrec and recursion');
(letrec ((factorial
           (lambda (n)
             (if n (* n (factorial (- n 1)))
                   1))))
  (factorial 4))
EOF

# vim: ft=perl
